interface

uses
  .., mMailer10;

const
// SSL certicates
  RootCertFile = 'certroot.pem';
  CertFile     = 'cert.crt';
  KeyFile      = 'cert.key';
  Password     = 'xyz123';

type
  TMailTestMain = class(TForm)
    ...
    mMailer      : TmMailer;
    end;
    
resourcestring
  rsMailError = 'Error during mail delivery (SMTP: %s:%u)';
  rsNoDeliver = 'Could not deliver mail to %s';
  rsMailSuccess = 'Mail was sent to: %s';

implementation

procedure TMailTestMain.FormCreate(Sender: TObject);
begin
  mMailer:=TmMailer.Create(self,PrgPath,RootCertFile,CertFile,KeyFile,Password);
  end;
  
procedure TMailTestMain.FormDestroy(Sender: TObject);  
begin
  mMailer.Free; 
  end;
  
procedure TMailTestMain.TestBtnClick(Sender: TObject);
var
  ok : boolean;
  s,lf : string;
  i  : integer;
begin
  with mMailer do begin
    Enabled:=false;
    ContentType:=ctUtf8;
    Application.ProcessMessages;
    ClearBody;
    Subject:='Test mail';
    AddToBody('This is a test!');
    Recipients.EMailAddresses:=lbRecipients.Items.CommaText;
    Host:=edServer.Text;
    Port:=edPort.Value;
    UserID:=edUsername.Text;
    Password:=edPwd.Text;
    SecureTransfer:=fSecureMode;
    HeloName:='MailTest';
    lf:=TempDir+SmtpLogName;
    LogName:=lf;
    WriteLogFile:=true;
    with From do begin
      if Pos('@',edSender.Text)>0 then begin
        Name:=ProgGroup; Address:=edSender.Text;
        end
      else begin
        Name:=edSender.Text; Address:=edReply.Text;
        end;
      end;
    Attachments.AttachedFiles.Clear;
    // Extra headers
    ClearExtraHeaders;
    AddExtraHeader('User-Agent',BuMainForm.ProgVersName);
    AddExtraHeader('Sender',From.Address);
    AddExtraHeader('Reply-To',edReply.Text);
    Enabled:=true;
    try ok:=Send; except ok:=false; end;
    with StatusWindow do if Visible then Close;
    WriteLogFile:=false;
    if not ok or (length(ErrorList)>0) then begin
      s:=Format(rsMailError,[Host,Port]);
      for i:=0 to High(ErrorList) do with ErrorList[i] do begin  // Fehlerliste
        if ErrType=seFailedRecipient then s:=s+sLineBreak+' - '+Format(rsNoDeliver,[ErrMsg])
        else s:=s+sLineBreak+' - '+ErrMsg;
        end;
//      Free;
      ShowMailTestResult(s,lf,mtError);
      end
    else begin
      s:=AnsiReplaceStr(Format(rsMailSuccess,[Recipients.EMailAddresses]),': ',':'+sLineBreak);
//      Free;
      ShowMailTestResult(s,lf,mtInformation);
      end;
    end;
  end;
